from KMeansAD import KMeansAD
import sys
import pathlib
sys.path.append(str(pathlib.Path.absolute)+ '../../')
from src.utils.slidingWindows import find_length_rank
from src.run_model_wrapper import main

#optimal hyperparameters from autors: {'periodicity': 2, 'n_clusters': 10}
params = {
        'periodicity': [1, 2, 3],
        'n_clusters': [10, 20, 30, 40],
}

def run_KMeansAD_U(data, n_clusters=20, periodicity=1,n_jobs=1):
    slidingWindow = find_length_rank(data, rank=periodicity)
    clf = KMeansAD(k=n_clusters, window_size=slidingWindow, stride=1, n_jobs=n_jobs)
    score = clf.fit_predict(data)
    return score.ravel()

model = 'run_KMeansAD_U'
output_path = '../../../docs/evaluation/'

#writes results in .csv
main(run_KMeansAD_U,params,model,data_folders = '../../../data/', model_type='unsupervised',output_dir = output_path)

#pip3 install -r requirements.txt
# python src/models/desi/call_poly.py