from OCSVM import OCSVM
import sys
import pathlib
sys.path.append(str(pathlib.Path.absolute)+ '../../')
from src.utils.slidingWindows import find_length_rank
from src.run_model_wrapper import main

#optimal hyperparameters from autors: {'periodicity': 2, 'kernel': 'rbf'}
params = {
        'periodicity': [1, 2, 3],
        'kernel': ['linear', 'poly', 'rbf', 'sigmoid']
    }

def run_Sub_OCSVM(data_train, data_test, kernel='rbf', nu=0.5, periodicity=1, n_jobs=1):
    slidingWindow = find_length_rank(data_test, rank=periodicity)
    clf = OCSVM(slidingWindow=slidingWindow, kernel=kernel, nu=nu)
    clf.fit(data_train)
    score = clf.decision_function(data_test)
    return score.ravel()

model = 'OCSVM'
output_path = '../../../docs/evaluation/'

#writes results in .csv
main(run_Sub_OCSVM,params,model,data_folders = '../../../data/', model_type='semi-supervised',output_dir = output_path)

#pip3 install -r requirements.txt
# python src/models/desi/call_poly.py