from PCA import PCA
import sys
import pathlib
sys.path.append(str(pathlib.Path.absolute)+ '../../')
from src.utils.slidingWindows import find_length_rank
from src.run_model_wrapper import main

#optimal hyperparameters: {'periodicity': 1, 'n_components': None}
params = {
        'periodicity': [1, 2, 3],
        'n_components': [0.25, 0.5, 0.75, None]
}

def run_Sub_PCA(data, periodicity=1, n_components=None, n_jobs=-1):
    slidingWindow = find_length_rank(data, rank=periodicity)
    clf = PCA(slidingWindow = slidingWindow, n_components=n_components)
    clf.fit(data)
    score = clf.decision_scores_
    return score.ravel()

model = 'PCA'
output_path = '../../../docs/evaluation/'


#writes results in .csv
main(run_Sub_PCA,params,model,data_folders = '../../../data/', model_type='unsupervised',output_dir = output_path)

#pip3 install -r requirements.txt
# python src/models/desi/call_poly.py