from SAND import SAND
import sys
import pathlib
import os
BASE_DIR = os.path.abspath(os.path.join(os.path.dirname(__file__), '../../../'))
if BASE_DIR not in sys.path:
    sys.path.append(BASE_DIR)
from src.utils.slidingWindows import find_length_rank
from src.run_model_wrapper import main
import warnings
warnings.simplefilter(action='ignore', category=FutureWarning)
warnings.simplefilter(action='ignore', category=UserWarning)

#optimal hyperparameter from autors: {'periodicity': 1}
params = {
        'periodicity': [1, 2, 3]
}

def run_KShapeAD(data, periodicity=1):
    slidingWindow = find_length_rank(data, rank=periodicity)
    clf = SAND(pattern_length=slidingWindow, subsequence_length=4*(slidingWindow))
    clf.fit(X=data.squeeze(),online=False, overlaping_rate=int(1.5*slidingWindow))
    score = clf.decision_scores_
    return score.ravel()

model = 'KShapeAD'
output_path = '../../../docs/evaluation/'

#writes results in .csv
main(run_KShapeAD,params,model,data_folders = '../../../data/', model_type='unsupervised',output_dir = output_path)

#pip3 install -r requirements.txt
# python src/models/desi/call_poly.py