from IForest import IForest
import sys
import pathlib
sys.path.append(str(pathlib.Path.absolute)+ '../../')
from src.utils.slidingWindows import find_length_rank
from src.run_model_wrapper import main

#optimal hyperparameters from autors: {'periodicity': 1, 'n_estimators': 150}
params = {
        'periodicity': [1, 2, 3],
        'n_estimators': [25, 50, 100, 150, 200]
}

def run_Sub_IForest(data, periodicity=1, n_estimators=100, max_features=1, n_jobs=-1):
    slidingWindow = find_length_rank(data, rank=periodicity)
    clf = IForest(slidingWindow=slidingWindow, n_estimators=n_estimators, max_features=max_features, n_jobs=n_jobs)
    clf.fit(data)
    score = clf.decision_scores_
    return score.ravel()

model = 'Sub_IForest'
output_path = '../../../docs/evaluation/'

#writes results in .csv
main(run_Sub_IForest,params,model,data_folders = '../../../data/', model_type='unsupervised',output_dir = output_path)

#pip3 install -r requirements.txt
# python src/models/desi/call_poly.py